#import <Cocoa/Cocoa.h>
#import <AddressBook/AddressBook.h>

@interface methods : NSObject
+ (ABPerson *)getMe;
+ (NSArray *)getABRecordFromID:(NSString *)theID updateImageView:(NSImageView *)imageView;
@end

@implementation methods
+ (ABPerson *)getMe {
    return [[ABAddressBook sharedAddressBook] me];
}

+ (NSArray *)getABRecordFromID:(NSString *)theID updateImageView:(NSImageView *)imageView {
    ABPerson *person = nil;
    NSString *first_name = @"";
    NSString *last_name = @"";
    NSString *company = @"";
    NSString *email = @"";
    NSImage *personImage;
    
    person = (ABPerson *)[[ABAddressBook sharedAddressBook] recordForUniqueId:theID];
    if (person) {
		first_name = [person valueForProperty:kABFirstNameProperty];
		if (!first_name)
			first_name = @"";
		last_name = [person valueForProperty:kABLastNameProperty];
		if (!last_name)
			last_name = @"";
		company = [person valueForProperty:kABOrganizationProperty];
		if (!company)
			company = @"";
		if ([person imageData]) {
			personImage = [[NSImage alloc] initWithData:[person imageData]];
		} else {
			personImage = [NSImage imageNamed:@"notfound"];
		}
		[imageView setImage:personImage];
		[personImage release];
		ABMultiValue *emails = [person valueForProperty:kABEmailProperty];
		if (emails) {
			int count = [emails count];
			int i;
			for (i = 0; i < count; i++) {
				email = [emails valueAtIndex:i];
				if(![email isEqualToString:@""]) {
					break;
				}
			}
		}
    }
    return [NSArray arrayWithObjects:first_name, last_name, company, email, nil];
}
@end
